/*******************************************************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced

Project :  ( . RTC)      ( +- 59 .)
          + 
          +      (DS18S20 / DS18B20)  
          +   (4-  7- )
          +    
          +   
          +    / 


          -------------------------------------------------------
          *  / ()  (ru.wikipedia.org):

                   .    ( 23,5)
             ,           .
             ( 66,33)       (    ),
             (   ). ,          30  55.


Version :   , ,   /   .  
Date    : 04.05.2010
Author  : Danil Pervakov                            
                           
Comments:    DS18x20 (   int  float)
           DS1307 ( -  -    
          - )

             :     
          ,    . (   )

           : "+" -  ..  - " +" 
                               -  ..  - " +"
                               -  .. - "  +"
                               -    -  
                               
                           "-" -  ..  - " -" 
                               -  ..  - " -"
                               -  .. - "  -"
                               -    -  
                               
                           "Sec" -     :
                                       :
                                   (  :  "" -    00,
                                      30  -  +1, 
                                    59 ,   +1)
                                   
                           "Set" -      
                                         
                                   :  ,  ,  ,
                                      , , ,
                                        :
                                   
                           "" -   .  .  ,
                                  0  0    -   00:00:00,  
                                  23  59    -   00:00:00,
                                        



Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
********************************************************************************************/
//
//  Fuse bit's SKSEL3..0 = 0011, SUT1..0 = 10 (Int RC = 4 MHz) 
//
//   DS1820 / DS18S20 / DS18B20 - (PORTD bit 7)
//  
//  Realtime DS1307 - (TWI sda -  27, scl -  28)
//
//   -  (ADC0 -  23) - "+", "-", "Sec", "Set", "K" 
//
//    (..  )
//                   (PORTB - ) - a-bit0, b-bit2, c-bit4, d-bit6, e-bit7, f-bit1, g-bit3, dp-bit5
//                   (PORTD - ) - 1-bit0, 2-bit1, 3-bit2, 4-bit3 
//
//    (ADC1)
//


/*
EEPROM usage: 0 byte(s), 0,0% of EEPROM
Program size: 2404 words (4808 bytes), 58,7% of FLASH
*/

//  -          ,    IBM PC XT   Intel 8088 
#include <mega8.h>

// 1 Wire Bus functions (PORTD bit 7)
#asm
   .equ __w1_port=0x12
   .equ __w1_bit=7
#endasm

// DS18S20 / DS18B20 Temperature Sensor functions
#include "ds18x20_v3.h"  

// I2C Bus functions (PORTC bit's  4, 5)
#asm
   .equ __i2c_port=0x15
   .equ __sda_bit=4
   .equ __scl_bit=5
#endasm

// DS1307 Real Time Clock functions (I2C -  )
#include "ds1307_.h"

#include <delay.h> 
#include <bcd.h>

// ,   . 
#include "term_mega8.h"

// -----------------------------------------------------------------------------------------
// Timer 0 overflow interrupt service routine
//
// 3906 Hz / 1953 = 2.000 Hz
// 65536 - 1953 = 63583 (0xF85F)
//
// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void){
    TCNT1H=0xF8;    
    TCNT1L=0x5F;

    for (cur_dig=0;cur_dig<4;cur_dig++) {
        PORTB=digits[digit_out[cur_dig]];           //    

        if ((zpt_ON == 1) && (cur_dig == 1)) PORTB|=0b00100000;  //     ( .  )

        PORTD|=(cursor[cur_dig]);                   //   
        PORTD&=0b11110000;
    }
    
    if (zpt_BLINK == 1) {
        if (zpt_ON == 0) zpt_ON=1; else zpt_ON=0; //   (1 )
    }
}//-----------------------------------------------------------------------------------------


// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void) {
    TCNT2=0xD9;

    PORT_100HZ = 1;
}

// Timer2 output compare interrupt service routine
interrupt [TIM2_COMP] void timer2_comp_isr(void){
    PORT_100HZ = 0;
}


// -----         --------------
// 
//          ( 2009   29 , 2010  28 ).
//          ( 2009   25 ,  2010  31 ).
//
void date_LetoZima(void) {
unsigned char y;

	y = bcd2bin(myyear);
		
	//        (ru.wikipedia.org)
	// a = (14 - ) / 12
	// y =  - a
	// m =  + 12 * a - 2
	//  = (7000 + ( + y + y / 4 - y / 100 + y / 400 + (31 * m) / 12))  7
	

	// __ = 31  __31_
	last_sunday_March   = bin2bcd(31 - ((33 + y + (y>>2)) % 7));

	// __ = 31  __31_
	last_sunday_October = bin2bcd(31 - ((51 + y + (y>>2)) % 7));
} // ---------------------------------------------------------------------------------------


//-----------------    (    ) --------------
unsigned char Zima_or_Leto(void) {

	//    c 3:00  23:00,
	//  c 1:00  23:00      ,
	//  c 1:00  23:00     ,
	//   1:00  23:00      
	if (((mymonth == 0x03) && (mydate == last_sunday_March) && (myhour >= 0x03) && (myhour < 0x23)) 
	   || ((mymonth == 0x03) && (mydate > last_sunday_March) && (myhour > 0x00) && (myhour < 0x23)) 
	      || ((mymonth > 0x03) && (mymonth < 0x10) && (myhour > 0x00) && (myhour < 0x23))
	         || ((mymonth == 0x10) && (mydate < last_sunday_October) && (myhour > 0x00) && (myhour < 0x23))) {
		return LETO;
	}

	//    c 4:00  23:59,
	//  c 2:00  23:59      ,
	//  c 2:00  23:59     ,
	//  c 2:00  23:59     ,
	//   2:00  23:59      
	if (((mymonth == 0x10) && (mydate == last_sunday_October) && (myhour >= 0x04) && (myhour != 0x00)) 
	   || ((mymonth == 0x10) && (mydate > last_sunday_October) && (myhour != 0x00) && (myhour >= 0x02)) 
	      || ((mymonth > 0x10) && (myhour != 0x00) && (myhour >= 0x02))
	         || ((mymonth < 0x03) && (myhour != 0x00) && (myhour >= 0x02))
	            || ((mymonth == 0x03) && (mydate < last_sunday_March) && (myhour != 0x00) && (myhour >= 0x02))) {
		return ZIMA;
	}

	return NE_LETO_NE_ZIMA; //          	
}//-----------------------------------------------------------------------------------------



// --------------------------------  ADC ---------------------------------------------
// Read the 8 most significant bits of the AD conversion result
unsigned char read_adc(unsigned char adc_input) {
        ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
        // Delay needed for the stabilization of the ADC input voltage
        delay_us(10);
        // Start the AD conversion
        ADCSRA|=0x40;
        // Wait for the AD conversion to complete
        while ((ADCSRA & 0x10)==0);
        ADCSRA|=0x10;
        return ADCH;
}  //---------------------------------------------------------------------------------------


// ----------------------------    ------------------------------------
unsigned char read_key(void) {
	unsigned char key_adc;

	key_adc=read_adc(0);

	if                      (key_adc <=   3)  return KEY_PLUS;  // = 0 
	if ((key_adc >= 124) && (key_adc <= 130)) return KEY_MINUS; // = 1/2  255
	if ((key_adc >= 167) && (key_adc <= 173)) return KEY_SEC;   // = 2/3  255
	if ((key_adc >= 188) && (key_adc <= 194)) return KEY_SET;   // = 3/4  255
	if ((key_adc >= 201) && (key_adc <= 207)) return KEY_K;     // = 4/5  255
} // ---------------------------------------------------------------------------------------


// -----------------------------------------------------------------------------------------
void DS1307_init (void) {
        unsigned char tmphour, tmpmin, tmpsec1, tmpsec2;

        rtc_init(0, 0, 0); //    DS1307    
                           // (   - : rs=0, sqwe=0, out=0)

        //   (   )
        //myhour=0;  mymin=0;    mysec=0;   // 24:00:00
        //mydate=4; mymonth=5; myyear=10;   // 04.05.2010

        rtc_get_time(&tmphour, &tmpmin, &tmpsec1); //     
        delay_ms(1500);
        rtc_get_time(&tmphour, &tmpmin, &tmpsec2); //  1,5 .    

        if (tmpsec1 == tmpsec2) { //   1,5 .        
                rtc_set_time(0, 0, 0);  //  7 (CH)   DS1307    
                                        // (0 - , 1 - )
                rtc_set_date(0x04, 0x05, 0x10);//    = 04.05.2010
        }
}//-----------------------------------------------------------------------------------------


// ---------------------------    DS1307 ------------------------------------
void read_time(void) {
        rtc_get_time(&myhour, &mymin, &mysec);
        rtc_get_date(&mydate, &mymonth, &myyear);

        if (myhour == 0x23) K=1; //     23 

        if ((K == 1) && (Corect != 0) && (myhour == hour_k) && (mymin == min_k) && (mysec == sec_k)) { 
                myhour=0; mymin=0; mysec=0;
                rtc_set_time(0, 0, 0);
                K=0;                        //        
        }
        //     23:59: ( - )      00:00:00  
        //       23 
} //----------------------------------------------------------------------------------------


//----------        ? --- (   )--------
void view_time(void) {
        unsigned char tmp;

        if (indicate == IND_CLOCK) {            //  : 
                digit_out[0] = myhour >> 4;
                digit_out[1] = myhour & 0x0F;
                digit_out[2] = mymin >> 4;
                digit_out[3] = mymin & 0x0F;
        }

        if (indicate == IND_SEC){               //  : 
                digit_out[0] = mymin >> 4;
                digit_out[1] = mymin & 0x0F;
                digit_out[2] = mysec >> 4;
                digit_out[3] = mysec & 0x0F;
        }

        if (indicate == IND_SET_H) {            // .
                digit_out[0] = myhour >> 4;
                digit_out[1] = myhour & 0x0F;
                digit_out[2] = PROBEL;
                digit_out[3] = PROBEL;
        }

        if (indicate == IND_SET_M) {            // .
                digit_out[0] = PROBEL;
                digit_out[1] = PROBEL;
                digit_out[2] = mymin >> 4;
                digit_out[3] = mymin & 0x0F;
        }

        if (indicate == IND_SET_YR) {           // .
                digit_out[0] = myyear >> 4;
                digit_out[1] = myyear & 0x0F;
                digit_out[2] = 13;  // d1
                digit_out[3] = 1;
        }

        if (indicate == IND_SET_MN) {           // .
                digit_out[0] = mymonth >> 4;
                digit_out[1] = mymonth & 0x0F;
                digit_out[2] = 13;  // d2
                digit_out[3] = 2;
        }

        if (indicate == IND_SET_DT) {           // .
                digit_out[0] = mydate >> 4;
                digit_out[1] = mydate & 0x0F;
                digit_out[2] = 13;  // d3
                digit_out[3] = 3;
        }

        if (indicate == IND_SET_T1){            // .  
                tmp = bin2bcd(t_ind_clock);
                digit_out[0] = tmp >> 4;
                digit_out[1] = tmp & 0x0F;
                digit_out[2] = SYMBOL_T;
                digit_out[3] = 1;
        }

        if (indicate == IND_SET_T2){            // .  
                tmp = bin2bcd(t_ind_date);
                digit_out[0] = tmp >> 4;
                digit_out[1] = tmp & 0x0F;
                digit_out[2] = SYMBOL_T;
                digit_out[3] = 2;
        }

        if (indicate == IND_SET_T3){            // .  
                tmp = bin2bcd(t_ind_term);
                digit_out[0] = tmp >> 4;
                digit_out[1] = tmp & 0x0F;
                digit_out[2] = SYMBOL_T;
                digit_out[3] = 3;
        }

        if (indicate == IND_K){                 // . 
                tmp = bin2bcd(Corect);
                
                digit_out[0] = PROBEL;

                if ((Znak == 0) || (tmp == 0)) digit_out[1] = PROBEL;
                else                           digit_out[1] = MINUS;

                digit_out[2] = tmp >> 4;
                digit_out[3] = tmp & 0x0F;
        }
} //----------------------------------------------------------------------------------------



// ---------        ? ------- ( ) ------------------
void view_date(void) {
        if (indicate == IND_CLOCK) {           //  - 
                digit_out[0] = mydate >> 4;
                digit_out[1] = mydate & 0x0F;
                digit_out[2] = mymonth >> 4;
                digit_out[3] = mymonth & 0x0F;
        }
} //----------------------------------------------------------------------------------------


// ------------------------------     --------------------------------
void set_ind(void) {
    unsigned char key, tmp, max_date;
    key=read_key();

    if (key != 0) {
        tmp=bcd2bin(mymonth);
        max_date = date_of_month[tmp-1];

        //    
        if (((bcd2bin(myyear) % 4) == 0 ) && (tmp == 2)) max_date = 29;

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_CLOCK){
                if (key == KEY_SEC) {
                        indicate = IND_SEC;
                        zpt_BLINK=0;
                        zpt_ON=1;
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_H;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                if (key == KEY_K) {
                        indicate = IND_K;
                        zpt_BLINK=0;
                        zpt_ON=0;
                        Corect=rtc_read(MEM_CORECT); //   DS1307
                        Znak=rtc_read(MEM_ZNAK);
                }

                return;
        }
 
        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SEC){
                if (key == KEY_SEC) {
                        indicate = IND_CLOCK;
                        zpt_BLINK=1;
                        zpt_ON=1;
                }

                if (key == KEY_K) {
                        if (bcd2bin(mysec) > 30) {  //   30 
                                tmp=bcd2bin(mymin); //  +1
                                tmp++;
                                if (tmp >= 60) {  //   59 
                                        mymin=0;
                                        tmp=bcd2bin(myhour);
                                        tmp++;
                                        if (tmp >= 24) myhour=0; else myhour=bin2bcd(tmp); //   23  
                                } else mymin=bin2bcd(tmp);
                                        
                        }
                        rtc_set_time(myhour, mymin, 0);  //  00
                        view_time();
                }

                return;
        } 

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_H){
                if (key == KEY_PLUS) {
                        tmp=bcd2bin(myhour);
                        tmp++; if (tmp >= 24) tmp=0;         //   +1
                        myhour=bin2bcd(tmp);
                }

                if (key == KEY_MINUS) {
                        tmp=bcd2bin(myhour);
                        if (tmp == 0) {tmp = 23;}
                        else          {tmp--;   }            //   -1
                        myhour=bin2bcd(tmp);
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_M;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                rtc_set_time(myhour, mymin, mysec);
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_M){
                if (key == KEY_PLUS) {
                        tmp=bcd2bin(mymin);
                        tmp++; if (tmp > 59) tmp=0;          //  +1
                        mymin=bin2bcd(tmp);
                }

                if (key == KEY_MINUS) {
                        tmp=bcd2bin(mymin);
                        if (tmp == 0) {tmp = 59;}
                        else          {tmp--;   }            //  -1
                        mymin=bin2bcd(tmp);
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_YR;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                rtc_set_time(myhour, mymin, mysec);
                view_time();
                return;
        }


        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_YR){
                if (key == KEY_PLUS) {
                        tmp=bcd2bin(myyear);
                        tmp++; if (tmp > 99) tmp=9;             //  +1
                        myyear=bin2bcd(tmp);
                }

                if (key == KEY_MINUS) {
                        tmp=bcd2bin(myyear);
                        if (tmp < 9) {tmp = 99;}
                        else         {tmp--;   }                //  -1
                        myyear=bin2bcd(tmp);
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_MN;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                date_LetoZima();
                rtc_set_date(mydate, mymonth, myyear);
                month_corect = Zima_or_Leto();
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_MN){
                if (key == KEY_PLUS) {
                        tmp=bcd2bin(mymonth);
                        tmp++; if (tmp > 12) tmp = 1;           //  +1
                        mymonth=bin2bcd(tmp);
                }

                if (key == KEY_MINUS) {
                        tmp=bcd2bin(mymonth);
                        if (tmp <= 1) {tmp = 12;}
                        else          {tmp--;   }               //  -1
                        mymonth=bin2bcd(tmp);
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_DT;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                rtc_set_date(mydate, mymonth, myyear);
                month_corect = Zima_or_Leto();
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_DT){
                if (key == KEY_PLUS) {
                        tmp=bcd2bin(mydate);
                        tmp++; if (tmp > max_date) tmp = 1;     //  +1
                        mydate=bin2bcd(tmp);
                }

                if (key == KEY_MINUS) {
                        tmp=bcd2bin(mydate);
                        if (tmp == 1) {tmp = max_date;}
                        else          {tmp--;   }               //  -1
                        mydate=bin2bcd(tmp);
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_T1;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                rtc_set_date(mydate, mymonth, myyear);
                month_corect = Zima_or_Leto();
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_T1){
                if (key == KEY_PLUS) {  //   +1 
                        t_ind_clock++; if (t_ind_clock > 50) t_ind_clock = 5;
                }

                if (key == KEY_MINUS) { //   -1 
                        if (t_ind_clock <= 5) {t_ind_clock = 50;}
                        else                  {t_ind_clock--;   }
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_T2;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                tc1 = t_ind_clock * 5;
                rtc_write(MEM_T_IND_CLOCK,t_ind_clock);
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_T2){
                if (key == KEY_PLUS) { //   +1 
                        t_ind_date++; if (t_ind_date > 50) t_ind_date = 0;
                }

                if (key == KEY_MINUS) { //   -1 
                        if (t_ind_date == 0) {t_ind_date = 50;}
                        else                 {t_ind_date--;   }
                }

                if (key == KEY_SET) {
                        indicate = IND_SET_T3;
                        zpt_BLINK=0;
                        zpt_ON=0;
                }

                td2 = t_ind_date * 5;
                rtc_write(MEM_T_IND_DATE,t_ind_date);
                view_time();
                return;
        }

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_SET_T3){
                if (key == KEY_PLUS) { //   +1 
                        t_ind_term++; if (t_ind_term > 25) t_ind_term = 0;
                }

                if (key == KEY_MINUS) { //   -1 
                        if (t_ind_term == 0) {t_ind_term = 25;}
                        else                 {t_ind_term--;   }
                }

                if (key == KEY_SET) {
                        indicate = IND_CLOCK;
                        zpt_BLINK=1;
                        zpt_ON=1;
                }

                tt3 = t_ind_term * 10;
                rtc_write(MEM_T_IND_TERM,t_ind_term);
                view_time();
                return;
        }


        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (indicate == IND_K){
                if (Corect > 60) Corect=0; //    
                if (Znak > 1)    Znak=0;

                if (key == KEY_PLUS) {
                        if (Znak == 0) { //   
                                Corect++;
                                if (Corect >= 60) {Corect=59; Znak=1;} //      
                        }
                        else { //   
                                Corect--;
                                if (Corect == 0) Znak=0; //    0    
                        }
                }

                if (key == KEY_MINUS) {
                        if (Znak == 0) { //   
                                if (Corect == 0) {Corect=2; Znak=1;} //  0    
                                Corect--;                                
                        }
                        else { //   
                                Corect++;
                                if (Corect >= 60) {Corect=59; Znak=0;} //      
                        }
                }

                if ((key == KEY_SEC) || (key == KEY_SET) || (key == KEY_K)){
                        indicate = IND_CLOCK;
                        zpt_BLINK=1;
                        zpt_ON=1;
                        rtc_write(MEM_CORECT,Corect); //  ()  DS1307
                        rtc_write(MEM_ZNAK,Znak);

                        // ----------    ------------
                        //  ()       00:00:00
                        if (Znak == 1) {hour_k=0x00; min_k=0x00; sec_k=bin2bcd(Corect);   } //  , .  00:00: -> 00:00:00   
                        else           {hour_k=0x23; min_k=0x59; sec_k=bin2bcd(60-Corect);} //  , .  23:59: -> 00:00:00  
                }

                return;
        }  
    }
} // ---------------------------------------------------------------------------------------



// -----------------------------------------------------------------------------------------
void view_term(void) {
    unsigned char celie, drob, tmp;
    unsigned int temp, celie_tmp, drob_tmp;

    zpt_ON=0;

    if (indicate != IND_CLOCK) return;

    temp = (unsigned int) temperature;
        
    if (temperature>=0) {
        digit_out[0]=PROBEL;       //   ()  
    } 
    else {        
        temp = ( ~temp ) + 0x0001; //       . 
        digit_out[0]=MINUS;        //     (   ..)
    }

    celie_tmp = temp >> 4;              //   
    drob_tmp  = temp & 0x000F;          //      1/16 

    drob  = (unsigned char) ((drob_tmp * 10) / 16); //      "1/16 "      0,1  
    
    celie = (unsigned char) celie_tmp;  //     

    // ************************************************************************************
    if (drob >= 5) celie++; //      -     
    // ************************************************************************************

    if (celie >= 100) { tmp=bin2bcd(celie-100); digit_out[0] = 1;} else tmp=bin2bcd(celie); //   
              
    if ((celie >= 100) || ((digit_out[0] == MINUS) && (celie >= 10))) { //    100,0 .   .  -10  1 .
        digit_out[1] = tmp >> 4;    // 
        digit_out[2] = tmp & 0x0F;  //  
        digit_out[3] = GRADUS;
    }
        
    if ((digit_out[0] == MINUS) && (celie < 10)) { //  . 0   -10  0,1 .
        digit_out[1] = celie; // 
        digit_out[2] = GRADUS;
        digit_out[3] = SYMBOL_C; 
    }
        
    if ((digit_out[0] == PROBEL) && (celie < 100)) { //  .  100,0    0   0,1 .
                if (tmp >> 4) digit_out[0] = tmp >> 4; //  -       
                digit_out[1] = tmp & 0x0F;             // 
                digit_out[2] = GRADUS;
                digit_out[3] = SYMBOL_C; 
    }
}  // --------------------------------------------------------------------------------------


// -----------------------------------------------------------------------------------------
void set_yarkost (void) 
{
	unsigned char adc_rez;

	adc_rez  = read_adc(1);

	if (adc_rez <= 128) 
        {
	TCCR2=0x00;     //  2,  100%
	PORT_100HZ = 0;
	}
	else
	{
	TCCR2=0x07;     //  2
	//#asm("cli")
	//OCR2 = 0xD9+(adc_rez/4); //  0  100%     0  152
	//#asm("sei")
	}

	if ((adc_rez > 128) && (adc_rez <= 192)) 
	{
	#asm("cli")
	OCR2 = 0xE2; //  75%
	#asm("sei")
	}

	if (adc_rez > 192) 
	{
	#asm("cli")
	OCR2 = 0xF0; //  50%
	#asm("sei")
	}

}
// -----------------------------------------------------------------------------------------
void delay_100ms (unsigned char d) {
	while (d) {
		read_time();
		set_ind();
		set_yarkost();
		delay_ms(90);
		d--;
	}
}

//===================================== main ==============================================
void main(void) {
unsigned char i, tmp, devices;
int t_tmp;

//  
digit_out[0]=PROBEL;
digit_out[1]=PROBEL;
digit_out[2]=PROBEL;
digit_out[3]=PROBEL;

#include "mega8.init" //  

w1_init();            // 1 Wire Bus initialization

i2c_init();           // I2C Bus initialization

DS1307_init();        //  DS1307

//   DS1307
Corect       = rtc_read(MEM_CORECT);
Znak         = rtc_read(MEM_ZNAK);
month_corect = rtc_read(MEM_MONTH_CORECT);

//      "" 
if (Znak > 1)         { Znak = 0;            rtc_write(MEM_ZNAK, Znak);        }
if (Corect > 60)      { Corect = 0;          rtc_write(MEM_CORECT, Corect);    }
if (month_corect > 1) { month_corect = ZIMA; rtc_write(MEM_MONTH_CORECT,ZIMA); }

t_ind_clock = rtc_read(MEM_T_IND_CLOCK); //    (.)
t_ind_date  = rtc_read(MEM_T_IND_DATE);  //                 
t_ind_term  = rtc_read(MEM_T_IND_TERM);  //                 

//    ( 5  50 )
if ((t_ind_clock < 5) || (t_ind_clock > 50)) { t_ind_clock = 10; rtc_write(MEM_T_IND_CLOCK, t_ind_clock); }
tc1 = t_ind_clock * 5;

//    ( 0  50 )
// 0 ->     
if (t_ind_date > 50) { t_ind_date = 10; rtc_write(MEM_T_IND_DATE, t_ind_date); }
td2 = t_ind_date * 5;

//    ( 0  25 )
// 0 ->     
if (t_ind_term > 25) { t_ind_term = 5; rtc_write(MEM_T_IND_TERM, t_ind_term); }
tt3 = t_ind_term * 10;

//   ( )
devices=w1_search(0xf0,rom_code);

indicate = IND_CLOCK; //    
zpt_BLINK=0;
zpt_ON=0;             //  

// Global enable interrupts
#asm("sei")

//  2     Fnd.'-  '
digit_out[0]=SYMBOL_F;
digit_out[1]=SYMBOL_N;
digit_out[2]=SYMBOL_D;
digit_out[3]=devices;  // 'devices'

// ..       
//      
if (devices >= 1) {
	for (i=0;i<devices;i++) {
		if (rom_code[i][0] == DS18B20_FAMILY_CODE){
			//t_tmp=ds18b20_temperature(&rom_code[i][0]); 
			ds18b20_init(&rom_code[i][0],DS18B20_9BIT); 
		}
		if (rom_code[i][0] == DS18S20_FAMILY_CODE){
			t_tmp=ds18s20_temperature(&rom_code[i][0]); 
		}
		delay_ms(1000);
	}
} else {
	delay_ms(2000);
}


zpt_BLINK=1; //   
zpt_ON=1;


 // --------------------------------   -----------------------------------
 while (1) {

        //      
        if (indicate == IND_CLOCK) {
            read_time();
            date_LetoZima();

            //     ,    "" 
            if (month_corect == ZIMA) { 
                if (Zima_or_Leto() == LETO) {
                    tmp = bcd2bin(myhour); tmp++; //     
                    myhour = bin2bcd(tmp);
                    rtc_set_time(myhour, mymin, mysec); 

                    month_corect = LETO;                      //  
                    rtc_write(MEM_MONTH_CORECT,month_corect); //     DS1307
                }
            } 
            //     ,    "" 
            else {
                if (Zima_or_Leto() == ZIMA) {
                    tmp = bcd2bin(myhour); tmp--; //     
                    myhour = bin2bcd(tmp);
                    rtc_set_time(myhour, mymin, mysec); 

                    month_corect = ZIMA;                      //  
                    rtc_write(MEM_MONTH_CORECT,month_corect); //     DS1307
                }
            }
        }


			for (i=0;i<tc1;i++){ //  
					read_time();
					view_time();
					set_ind();
					set_yarkost();
					delay_ms(200);
			}


        //         
        if ((t_ind_date!=0) && (indicate == IND_CLOCK)) {
                zpt_BLINK=0;
                zpt_ON=0;

                for (i=0;i<td2;i++){ //  
                        read_time();
                        view_date();
                        set_ind();
                        set_yarkost();
                        delay_ms(200);
                }

                zpt_BLINK=1;
                zpt_ON=1;
        }


        //           
        if ((devices >= 1) && (indicate == IND_CLOCK) && (t_ind_term != 0)) {
                zpt_BLINK=0;
                zpt_ON=0;

                for (i=0;i<devices;) {
                        if (rom_code[i][0] == DS18B20_FAMILY_CODE){
                             temperature=ds18b20_temperature(&rom_code[i][0]); 
                        }
                        if (rom_code[i][0] == DS18S20_FAMILY_CODE){
                             temperature=ds18s20_temperature(&rom_code[i][0]); 
                        }     
                        if (temperature!=-9999) view_term();
                        delay_100ms(tt3);
                        i++;
                }

                zpt_BLINK=1;
                zpt_ON=1;
        }

 } // -----------------------------   (end) ------------------------------------

} // =================================== end main ==========================================





//
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- The End -=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//