#define ZIMA 0
#define LETO 1
#define NE_LETO_NE_ZIMA 99

#define OFF 0
#define ON  1

//   

// 8 ,   = 2.56 
//#define ADC_VREF_TYPE 0xE0

// 8 ,   = AVCC
#define ADC_VREF_TYPE 0x60

// 8 ,   = AREF
//#define ADC_VREF_TYPE 0x20

// 10 ,   = 2.56 
//#define ADC_VREF_TYPE 0xC0

// 10 ,   = AVCC
//#define ADC_VREF_TYPE 0x40

// 10 ,   = AREF
//#define ADC_VREF_TYPE 0x00


#define A   1
#define B   4
#define C  16 
#define D  64  
#define E 128 
#define F   2 
#define G   8 

static flash unsigned char digits[] = {
	(A+B+C+D+E+F),   // 0
	(B+C),           // 1
	(A+B+D+E+G),     // 2
	(A+B+C+D+G),     // 3
	(B+C+F+G),       // 4
	(A+C+D+F+G),     // 5
	(A+C+D+E+F+G),   // 6
	(A+B+C),         // 7
	(A+B+C+D+E+F+G), // 8
	(A+B+C+D+F+G),   // 9
	(A+B+C+E+F+G),   // A - 10
	(C+D+E+F+G),     // b - 11
	(A+D+E+F),       // C - 12
	(B+C+D+E+G),     // d - 13
	(A+D+E+F+G),     // E - 14
	(A+E+F+G),       // F - 15
	(G),             // 16 -  
	(A+B+F+G),       // 17 -   
	(0),             // 18 - 
	(C+E+G),         // n
	(D+E+F+G)        // t
};

#define MINUS  16
#define GRADUS 17
#define PROBEL 18
#define SYMBOL_F 15
#define SYMBOL_N 19
#define SYMBOL_D 13
#define SYMBOL_C 12
#define SYMBOL_T 20

// ------------------------------------- digit1,     digit2,     digit3,     digit4
// ------------------------------------~~~~~~~_    ~~~~~~_~    ~~~~~_~~    ~~~~_~~~
static flash unsigned char cursor[]={0b00000001, 0b00000010, 0b00000100, 0b00001000}; 

//  : -, -,   , 
//                  ., ., ., ., .,
//                  .  , .  ,
//                  .   
#define IND_CLOCK      0
#define IND_SEC        1
#define IND_K          2
#define IND_SET_H      3
#define IND_SET_M      4
#define IND_SET_YR     5
#define IND_SET_MN     6
#define IND_SET_DT     7
#define IND_SET_T1     8
#define IND_SET_T2     9
#define IND_SET_T3    10

// 
#define KEY_PLUS  1
#define KEY_MINUS 2
#define KEY_SEC   3
#define KEY_SET   4
#define KEY_K     5

//   DS1307    
#define MEM_CORECT        9
#define MEM_ZNAK         10
#define MEM_MONTH_CORECT 11
#define MEM_T_IND_CLOCK  12
#define MEM_T_IND_DATE   13
#define MEM_T_IND_TERM   14

#define PORT_100HZ PORTD.4  //  100 Hz ( )

unsigned char digit_out[4], //   
                   cur_dig, // .  ()
                  indicate, // . (  = IND_CLOCK, ...)
                    zpt_ON, // =1 -   ()
                 zpt_BLINK, // =1 -  
                    Corect, //  (.)
                      Znak, // =0 - .(), =1 .() 
                         K; //   

int temperature; // ,    DS18B20

unsigned char t_ind_clock, tc1, //    (.)    (- )
              t_ind_date,  td2, //    -- // --     
              t_ind_term,  tt3; //    -- // --     

//        ,   - 
unsigned char myhour, mymin, mysec,    //  
              mydate, mymonth, myyear, //  
              last_sunday_March,       //   
              last_sunday_October,     // -- // --              
              month_corect;            //       / 
              
const unsigned char date_of_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};

unsigned char hour_k=0x25, min_k, sec_k; //   (0x25 = .25 ..  )

// maximum number of DS18x20 connected to the 1 Wire bus
#define MAX_DEVICES 4

// DS18x20 devices ROM code storage area
unsigned char rom_code[MAX_DEVICES][9];
